
#include "mkhibview.h"


short iscomp(HANDLE h) {
  return (h_getCompTag(h_getFileType(HeapDeref(h))) == ZIP_TAG);
}

HANDLE uncomp(short id, HANDLE h) {
  
  if (id != TRUE) {
    return H_NULL;
  }
  
  unsigned char * data = HLock(h);
  if (data == NULL) {
    return H_NULL;
  }
  
  InfosComp infos = GetInfosComp(data);
  if (!is_compressed_ziplib(infos)) {
    return H_NULL;
  }
  
  unsigned short size = get_size_var(infos);
  
  HANDLE h_uncomp = HeapAlloc(size+2);
  if (h_uncomp == H_NULL)
  {
    HeapUnlock(h);
    return H_NULL;
  }
  
  unsigned char * data_uncomp = HLock(h_uncomp);
  
  if (data_uncomp == NULL) {
    HeapFree(h_uncomp);
    HeapUnlock(h);
    return H_NULL;
  }
  
  if (dzip_data(data+2, *(unsigned short *)data, data_uncomp)) {
    HeapFree(h_uncomp);
    HeapUnlock(h);
    return H_NULL;
  }
  
  return h_uncomp;
}
