// C Source File
// Created 27/07/2003; 11:59:25

#include "mkcomplib.h"

/*===============================================================================================
== Komp decompression
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the handle of the decompressed datas
===============================================================================================*/
CompErr dkomp_data(unsigned char * data, unsigned short length, unsigned char * dest) {
  TREE * tree=NULL;
  unsigned short file_len;
  unsigned short nL;

  CompErr error;
  
  error=study_dkomp(data,length,&tree,&file_len,&nL);
  
  if (error!=COMP_NO_ERR)
    return error;
  
  return mk_dkomp(data,dest,NULL,0,tree,nL,file_len);

}

