// C Source File
// Created 27/07/2003; 11:54:55

#include "mkcomplib.h"

/*===============================================================================================
== Ziplib decompression
=================================================================================================
== data : pointer of the data to decompress
== length : length of the data to decompress
== str_tag : a string which contain the tag to add atthe end of the file. For exemple :
'\0','E','X','T','\O',OTH_TAG
== tag_length : length of the tag (the tag doesn't finish by '\0' ! impossible to use strlen !)
== error : pointer to return the error code
=================================================================================================
== return the handle of the decompressed datas
===============================================================================================*/

CompErr dzip_data(unsigned char * data, unsigned short length, unsigned char * dest) {
  TREE * tree=NULL;
  short nL;
  unsigned short file_len;
  short byte_offset;
  short bit_offset;

  CompErr error;
  
  error=study_dzip(data,length,&tree,&nL,&file_len,&byte_offset,&bit_offset);

  if (error!=COMP_NO_ERR)
    return error;

  return mk_dzip(data,dest,NULL,0,tree,nL,file_len,byte_offset,bit_offset);

}

