
//====================================================
//================== define section ==================
//====================================================

#define HIBVIEWL_VERSION 200 

#define MIN_AMS 101
#define SAVE_SCREEN
#include <tigcclib.h>
#include "complib.h"

#include "key.h"

#include "texts.h"          //the texts in the defined language
#include "hibtypes.h"         //the library to to hibfile
#include "hiblib.h"         //the library to to hibfile
#include "hibliba.h"         //the library to to hibfile
#include "hiblang.h"

#define SPEED_KEY 60
#define ALWAYS_RETURN_TO_MENU
#define DRAW_LOG
#define PAGE_SCROLL_COMMON_BAND 10


typedef struct
{
  short drawSize;
  BOOL allowBigObject;
  short zoom;
} hVCfg;

extern short iscomp(HANDLE h);
extern HANDLE uncomp(short id, HANDLE h);

extern void loadConfig(hVCfg * config);
extern void saveConfig(hVCfg * config);
extern void optionsMenu(hVCfg * config, h_Config * hcfg);

extern short readhFile(short num_line, short * bookmark, unsigned char * name_var, h_File * hfile, h_Config * hcfg, h_I18nBookmark * hi18nbookmark, h_I18nLink * hi18nlink);

